/*
 * Copyright (C) 1999-2006 <a href="mailto:paschke@in.tum.de">Adrian Paschke</a>
 * 
 * The Regression Test is part of the Rule Based Service Level Agreement (RBSLA)
 * framework, available at 
 * <a href=" http://ibis.in.tum.de/staff/paschke/rbsla/index.htm">RBSLA</a>
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package rbsla.rmltoprova;

import org.jdom.*;
import java.util.*;


/**
 * Atom
 * 
 * Translates RuleML 0.86 Atoms into Prova predicates
 * 
 * @author <A HREF="mailto:adrian.paschke@gmx.de">Adrian Paschke</A>
 * @version 0.1 <1 Feb 2005>
 * @since 0.1
 * @deprecated Since RuleML 0.87 and RBSLA 0.1 XSLT Stylesheets are provided for translation
 */
public class Atom
{
    private Element atom;
    private String rel;

    private List termElements;
    private List termObjects;
    private Namespace ns;

    public Atom(Element _atom)
    {
        atom = _atom;
        ns = atom.getNamespace();
        rel = atom.getChild("_opr",ns).getChild("rel",ns).getText();
        termObjects = new ArrayList();
        termElements = atom.getChildren();

        for(int n = 1; n < termElements.size(); n++)
        {
            Element term = (Element)termElements.get(n);
            termObjects.add(Term.termControl(term));
        }
    }

    public String toString()
    {
        StringBuffer sb = new StringBuffer(rel + "(");
        for(int n = 0 ; n < termObjects.size(); n++)
        {
            Term term = (Term)termObjects.get(n);
            sb.append(term.toString());
            if(n != termObjects.size() - 1)
            {
                sb.append(", ");
            }
        }
        sb.append(")");
        return sb.toString();
    }
}